﻿-- Buff monitor

local width, height = 250, 22

BUFF_MAX_DISPLAY = 32
BUFF_ACTUAL_DISPLAY = 0

local v = SN.Media

function SN:Buffs()
	SN.F.buffs = SN.timers:NewGroup(250, "BuffGroup", buffgrp)
	SN.F.buffs:SetSpacing(0, 7)
	SN.F.buffs:SetStartPoint("bottomleft")
	SN.F.buffs:SetSorting("SN:arg5")
	if IsAddOnLoaded("ElvUI") then
		SN.F.buffs:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 3, -3)
	else
		BuffFrame:Hide()
		SN.F.buffs:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", -1, -25)
	end
	SN.F.buffs.BuffFrameUpdateTime = 0
	SN.F.buffs:SetScript("OnEvent", BuffGroup_OnEvent)
	SN.F.buffs:SetScript("OnUpdate", BuffGroup_OnUpdate)

	SN.F.buffs:RegisterUnitEvent("UNIT_AURA", "player", "vehicle")
	SN.F.buffs:RegisterEvent("GROUP_ROSTER_UPDATE")
	SN.F.buffs:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
	SN.F.buffs:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	SN.F.buffs.bufftable = {}
end

function BuffGroup_OnEvent(self, event, ...)
	local unit = ...
	if ( event == "UNIT_AURA" ) then
		if ( unit == PlayerFrame.unit ) then
			BuffGroup_Update(self)
		end
	elseif ( event == "GROUP_ROSTER_UPDATE" or event == "PLAYER_SPECIALIZATION_CHANGED" ) then
		BuffGroup_Update(self)
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		BuffGroup_Update(self)
	end
end

function BuffGroup_OnUpdate(self, elapsed)
	if ( self.BuffFrameUpdateTime > 0 ) then
		self.BuffFrameUpdateTime = self.BuffFrameUpdateTime - elapsed
	else
		self.BuffFrameUpdateTime = self.BuffFrameUpdateTime + TOOLTIP_UPDATE_TIME
	end
end

function BuffGroup_Update(self)
	-- Handle Buffs
	self:Clear()
	BUFF_ACTUAL_DISPLAY = 0
	for i=1, BUFF_MAX_DISPLAY do
		--if ( 
			BuffBars_Update(self, i, "HELPFUL") --) then
			BUFF_ACTUAL_DISPLAY = BUFF_ACTUAL_DISPLAY + 1
		--end
	end
end

function BuffBars_Update(group, index, filter)
	local unit = PlayerFrame.unit
	local name, rank, icon, count, debuffType, duration, expirationTime, _, _, shouldConsolidate, spellId = UnitBuff(unit, index, filter)
	--local buffName = barName..index
	--local buff = _G[buffName]
	if name then
	
		local tempbar = group:Find("SN:arg2", spellId)
		if ( tempbar == nil ) then
			buff = SN.timers:NewBar(group, width, height, v.media.minTex)
			class, classFileName = UnitClass("player")
			colortmp = RAID_CLASS_COLORS[classFileName]
			color = { colortmp.r, colortmp.g, colortmp.b }

			buff:SetIcon(icon)
			buff:SetData("SN:arg1", group)
			buff:SetData("SN:arg2", spellId)
			buff:SetData("SN:arg3", name)
			buff:SetData("SN:arg4", duration)
			buff:SetData("SN:arg5", index)
			buff:SetColor(color)
			
			buff:SetLabelFont(v.media.font, 14, "OUTLINE")
			buff:SetLabel(name)
			SN:SNCreateBG(buff)
			if expirationTime > 0 then
				buff:SetDuration(math.floor(-1*(GetTime() - expirationTime)))
				buff:Start()
			elseif expirationTime < 0 then
				buff:SetSpark(false)
				temp:SetDuration(nil)
				buff:Start()						
			end

			if ( duration > 0 and expirationTime ) then
				if ( not buff.timeLeft ) then
					buff.timeLeft = expirationTime - GetTime();
					buff:SetScript("OnUpdate", BuffBars_OnUpdate)
				else
					buff.timeLeft = expirationTime - GetTime()
				end			
				buff.expirationTime = expirationTime	
			else
				buff:SetScript("OnUpdate", nil)
				buff.timeLeft = nil
			end
		elseif tempbar ~= nil then
			if tempbar:GetData("SN:arg5") == index then
				if expirationTime > 0 then
					tempbar:SetDuration(math.floor(-1*(GetTime() - expirationTime)))
					tempbar:Start()
				elseif expirationTime < 0 then
					tempbar:SetSpark(false)
					temp:SetDuration(nil)
					tempbar:Start()						
				end
		
				if ( duration > 0 and expirationTime ) then
					if ( not buff.timeLeft ) then
						tempbar.timeLeft = expirationTime - GetTime();
						tempbar:SetScript("OnUpdate", BuffBars_OnUpdate)
					else
						tempbar.timeLeft = expirationTime - GetTime()
					end			
					tempbar.expirationTime = expirationTime	
				else
					tempbar:SetScript("OnUpdate", nil)
					tempbar.timeLeft = nil
				end
			else
				tempbar:SetData("SN:arg5", index)
				if expirationTime > 0 then
					tempbar:SetDuration(math.floor(-1*(GetTime() - expirationTime)))
					tempbar:Start()
				elseif expirationTime < 0 then
					tempbar:SetSpark(false)
					temp:SetDuration(nil)
					tempbar:Start()						
				end
		
				if duration > 0 and expirationTime then
					if not buff.timeLeft then
						tempbar.timeLeft = expirationTime - GetTime();
						tempbar:SetScript("OnUpdate", BuffBars_OnUpdate)
					else
						tempbar.timeLeft = expirationTime - GetTime()
					end			
					tempbar.expirationTime = expirationTime	
				elseif duration == 0 then
					tempbar:SetScript("OnUpdate", nil)
					tempbar.timeLeft = nil
				end
				--group:Remove(tempbar)
			end
		end
	end
end

function BuffBars_OnUpdate(bar)
	--local index = bar:GetData("SN:arg4")
	
	-- Update duration
	securecall("BuffBars_UpdateDuration", bar, bar.timeLeft) -- Taint issue with SecondsToTimeAbbrev
	bar.timeLeft = max(bar.expirationTime - GetTime(), 0)

	if ( SN.F.buffs.BuffFrameUpdateTime > 0 ) then
		return
	end
	--if ( GameTooltip:IsOwned(self) ) then
	--	GameTooltip:SetUnitAura(PlayerFrame.unit, index, self.filter)
	--end
end

function BuffBars_UpdateDuration(bar, timeLeft)
	local duration = bar:GetData("SN:arg4")

	print(bar:GetData("SN:arg3"))
	print(duration)
	print(timeLeft)
	print(bar:GetData("SN:arg5"))
	if ( timeLeft ) then
		bar:SetDuration(timeLeft)
		bar:Start()
		
	else
		if duration == 0 then
			bar:SetDuration(nil)
			bar:Start()
		else
			SN.F.buffs:Remove(bar)
		end
	end
end
--function SN:UpdateBuff(group, event, unit, ...)
--	local v = SN.Media
--	if event == "UNIT_AURA" then
--		for removebuff = 1, 40 do
			
--		end
--		for buffs = 1, 40 do 
--			local name, _, icon, _, _, duration, expiration, _, _ = UnitBuff("player", buffs)
--			if name then
--				local tempbar = group:Find("SN:arg2", name)
--				if tempbar ~= nil then4
--					tempbar:SetDuration(math.floor(-1*(GetTime() - expiration)))
--					tempbar:Start()
--				else
--					local bar = SN.timers:NewBar(group, width, height, v.media.minTex)
--					local class, classFileName = UnitClass("player")
--					local colortmp = RAID_CLASS_COLORS[classFileName]
--					color = { colortmp.r, colortmp.g, colortmp.b }

--					bar:SetIcon(icon)
--					bar:SetData("SN:arg1", group)
--					bar:SetData("SN:arg2", name)
--					bar:SetColor(color)
--					bar:SetDuration(math.floor(-1*(GetTime() - expiration)))
--					bar:SetLabelFont(v.media.font, 14, "OUTLINE")
--					bar:SetLabel(name)
--					SN:SNCreateBG(bar)
--				end
--			end
--		end			
--	end
--end

